import 'package:flutter/material.dart';
import 'dart:async';

import 'package:image_picker/image_picker.dart';
import 'package:watermark_shareable/watermark_shareable.dart';

void main() {
  runApp(MyApp());
}

class MyApp extends StatefulWidget {
  @override
  _MyAppState createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> {
  dynamic image;

  @override
  void initState() {
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: Scaffold(
        appBar: AppBar(
          title: const Text('Plugin watermark example'),
        ),
        body: SingleChildScrollView(
          child: Column(
            children: [
              Center(
                child: FlatButton(
                  onPressed: () {},
                  child: RaisedButton(
                    child: Text('Watermark'),
                    onPressed: () async {
                      getImage();
                    },
                  ),
                ),
              ),
              Container(
                padding: EdgeInsets.all(10),
                child: image != null ? Image.memory(image) : Container(),
              )
            ],
          ),
        ),
      ),
    );
  }

  Future getImage() async {
    var image2 = await ImagePicker.pickImage(source: ImageSource.gallery);
    try {
      var img =
          await WatermarkShareable.getPostWithWaterMark(image2.path, 'post');
      setState(() {
        image = img;
      });
    } catch (e, s) {
      print("Error ${e}, ${s}");
    }
  }
}
