import 'dart:async';
import 'package:flutter/services.dart';

class WatermarkShareable {
  static const MethodChannel _channel =
      const MethodChannel('watermark_shareable');

  static Future setImage({String image, String type}) async {
    return await _channel.invokeMethod('setImage', <String, String>{
      'imageUrl': image,
      'type': type,
    });
  }

  static Future<dynamic> getPostWithWaterMark(String image, String type) async {
    return await _channel.invokeMethod('getPostWithWaterMark', <String, String>{
      'image': image,
      'type': type,
    });
  }
}
